
#include "ExpressionTree.h"
#include "MyStack.h"
#include "common.h"
#include <string.h>

/*	 Ʈ ϴ Լ Ű  ǥ ƴ  ǥ ̴.
	ȯ  Ʈ Ʈ ̴.
*/
BTreeNode* MakeExpressionTree(char exp[])
{
	MyStack Stack;
	BTreeNode* pNode = NULL;

	int expLen = strlen(exp);
	int i;

	MyStackInit(&Stack);

	for ( i = 0; i < expLen; i++)
	{
		pNode = MakeBTreeNode();

		/*	( ) ̸, ÿ 带 .	*/
		if ('1' <= exp[i] && exp[i] <= '9')
		{
			SetData(pNode, exp[i] - '0');
		}
		/*	̸, 	*/
		else
		{
			SetData(pNode, exp[i]);

			/*	ÿ  2    ڽ ϰ ٽ ÿ .	*/
			MakeRightSubTree(pNode, Top(&Stack));
			Pop(&Stack);

			MakeLeftSubTree(pNode, Top(&Stack));
			Pop(&Stack);
		}

		Push(&Stack, pNode);
	}

	/*	 ÿ   ϳ ۿ .	*/
	pNode = Top(&Stack);
	Pop(&Stack);

	return pNode;
}

/*	 Ʈ ϴ Լ	*/
int EvaluateExpressionTree(BTreeNode* pNode)
{
	int leftOp, rightOp;

	/*	ܸ  ڸ  Ƿ,  ڸ 	*/
	if (GetLeftSubTree(pNode) == NULL && GetRightSubTree(pNode) == NULL)
		return GetData(pNode);

	/*	pNode   Ʈ   Ʈ 갪 ´.	*/
	leftOp = EvaluateExpressionTree(GetLeftSubTree(pNode));
	rightOp = EvaluateExpressionTree(GetRightSubTree(pNode));

	/*	 ϰ,   Ѵ.	*/
	switch (GetData(pNode))
	{
	case '*':	return leftOp * rightOp;
	case '/':	return leftOp / rightOp;
	case '+':	return leftOp + rightOp;
	case '-':	return leftOp - rightOp;
	}
	return 0;
}

/*	 Ʈ  ȸϿ ͸ ϴ Լ	*/
void PrefixExpTreeTraverse(BTreeNode* pNode)
{
	/*	 Լ Ż 	*/
	if (pNode == NULL)
		return;

	/*	͸ 		*/
	if (1 <= GetData(pNode) && GetData(pNode) <= 9)
		printf("%d ", GetData(pNode) );
	else
		printf("%c ", GetData(pNode));

	PrefixExpTreeTraverse(GetLeftSubTree(pNode));
	PrefixExpTreeTraverse(GetRightSubTree(pNode));
}

/*	 Ʈ  ȸϿ ͸ ϴ Լ	*/
void InfixExpTreeTraverse(BTreeNode* pNode)
{
	/*	 Լ Ż 	*/
	if (pNode == NULL)
		return;

	InfixExpTreeTraverse(GetLeftSubTree(pNode));

	/*	͸ 		*/
	if (1 <= GetData(pNode) && GetData(pNode) <= 9)
		printf("%d ", GetData(pNode));
	else
		printf("%c ", GetData(pNode));

	InfixExpTreeTraverse(GetRightSubTree(pNode));
}

/*	 Ʈ  ȸϿ ͸ ϴ Լ	*/
void PostfixExpTreeTraverse(BTreeNode* pNode)
{
	/*	 Լ Ż 	*/
	if (pNode == NULL)
		return;

	PostfixExpTreeTraverse(GetLeftSubTree(pNode));
	PostfixExpTreeTraverse(GetRightSubTree(pNode));

	/*	͸ 		*/
	if (1 <= GetData(pNode) && GetData(pNode) <= 9)
		printf("%d ", GetData(pNode));
	else
		printf("%c ", GetData(pNode));
}

/*	 Ʈ  ȸϿ Ұȣ  ͸  ϴ Լ	*/
void InfixExpTreeTraverseWithBrackets(BTreeNode* pNode)
{
	/*	 Լ Ż 	*/
	if (pNode == NULL)
		return;

	/*	pNode  ̸ ȣ 	*/
	if (GetLeftSubTree(pNode) != NULL || GetRightSubTree(pNode) != NULL)
		printf(" ( ");

	InfixExpTreeTraverseWithBrackets(GetLeftSubTree(pNode));

	/*	͸ 		*/
	if (1 <= GetData(pNode) && GetData(pNode) <= 9)
		printf("%d ", GetData(pNode));
	else
		printf("%c ", GetData(pNode));

	InfixExpTreeTraverseWithBrackets(GetRightSubTree(pNode));

	/*	pNode  ̸ ȣ 	*/
	if (GetLeftSubTree(pNode) != NULL || GetRightSubTree(pNode) != NULL)
		printf(" ) ");
}

